Attribute VB_Name = "PublicVars"
Option Explicit
'****************************************************************************************
'* Code downloaded from somewhere on the Internet - Sorry I forget where i found this.
'*****************************************************************************************

Public LongDateFMT() As String
Public ShortDateFMT() As String
Public TimeFMT() As String
Public iLDFs As Integer
Public iSDFs As Integer
Public iTFs As Integer
Public CurrencyFormat As CURRENCYFMT

Private enLongDate As Boolean

' If you have to ask what this API does...
Private Declare Function lstrcpyA Lib "kernel32" (ByVal NewString As String, ByVal OldString As Long) As Long
' Enumeration declares
Private Declare Function EnumDateFormats Lib "kernel32" Alias "EnumDateFormatsA" (ByVal lpDateFmtEnumProc As Long, ByVal Locale As Long, ByVal dwFlags As Long) As Long
Private Declare Function EnumTimeFormats Lib "kernel32" Alias "EnumTimeFormatsA" (ByVal lpTimeFmtEnumProc As Long, ByVal Locale As Long, ByVal dwFlags As Long) As Long
Private Declare Function GetCurrencyFormat Lib "kernel32" Alias "GetCurrencyFormatA" (ByVal Locale As Long, ByVal dwFlags As Long, ByVal lpValue As String, lpFormat As CURRENCYFMT, ByVal lpCurrencyStr As String, ByVal cchCurrency As Long) As Long
'Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long

Public Type CURRENCYFMT
        NumDigits As Long '  number of decimal digits
        LeadingZero As Long '  if leading zero in decimal fields
        Grouping As Long '  group size left of decimal
        lpDecimalSep As String              '  ptr to decimal separator string
        lpThousandSep As String             '  ptr to thousand separator string
        NegativeOrder As Long '  negative currency ordering
        PositiveOrder As Long '  positive currency ordering
        lpCurrencySymbol As String          '  ptr to currency symbol string
End Type

Private Const DATE_LONGDATE = &H2
Private Const DATE_SHORTDATE = &H1

Public Sub EnumFormats(ByVal LCID As Long)
' Enum the existing formats for the given locale
' Dates: Short formats, then long formats
' Reset arrays
ReDim ShortDateFMT(0)
ReDim LongDateFMT(0)
ReDim TimeFormats(0)
' Reset counters
iLDFs = 0
iSDFs = 0
iTFs = 0
enLongDate = False
EnumDateFormats AddressOf MLEDF, LCID, DATE_SHORTDATE
enLongDate = True
EnumDateFormats AddressOf MLEDF, LCID, DATE_LONGDATE
' Times
EnumTimeFormats AddressOf MLETF, LCID, 0&

End Sub


Public Function MLEDF(ByVal lpDF As Long) As Long
' Enum date formats proc

Dim dX As String
dX = String(255, Chr(0))

' Cast the string pointer into a VB string.
' Don't ask.
lstrcpyA dX, lpDF
dX = Left(dX, InStr(1, dX, Chr(0)) - 1)

If enLongDate Then
    On Error Resume Next
    ReDim Preserve LongDateFMT(UBound(LongDateFMT) + 1)
    If Err <> 0 Then ReDim LongDateFMT(1)
    LongDateFMT(UBound(LongDateFMT)) = dX
    iLDFs = iLDFs + 1
Else
    On Error Resume Next
    ReDim Preserve ShortDateFMT(UBound(ShortDateFMT) + 1)
    If Err <> 0 Then ReDim ShortDateFMT(1)
    ShortDateFMT(UBound(ShortDateFMT)) = dX
    iSDFs = iSDFs + 1
End If

MLEDF = 1
End Function

Public Function MLETF(ByVal lpTF As Long) As Long
' Enum time formats proc
Dim tX As String
tX = String(255, Chr(0))
' Cast string pointer as VB compatible string
' Don't ask.
lstrcpyA tX, lpTF
tX = Left(tX, InStr(1, tX, Chr(0)) - 1)
On Error Resume Next
ReDim Preserve TimeFMT(UBound(TimeFMT) + 1)
If Err <> 0 Then ReDim TimeFMT(1)
TimeFMT(UBound(TimeFMT)) = tX
iTFs = iTFs + 1
MLETF = 1
End Function
