VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Locale"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
Option Compare Text
Option Base 0

Public Enum lDateFormat
    lLongDate = 1
    lShortDate = 2
End Enum


Private mvPrLang As Long
Private mvSubLang As Long
Private mvLCID As Long
Private mvDF As DTFormats
Private mvTF As DTFormats

Private Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" (ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String, ByVal cchData As Long) As Long
Private Declare Function IsValidLocale Lib "kernel32" (ByVal Locale As Long, ByVal dwFlags As Long) As Long
Private Declare Function GetCurrencyFormat Lib "kernel32" Alias "GetCurrencyFormatA" (ByVal Locale As Long, ByVal dwFlags As Long, ByVal lpValue As String, lpFormat As Long, ByVal lpCurrencyStr As String, ByVal cchCurrency As Long) As Long
Private Declare Function GetDateFormat Lib "kernel32" Alias "GetDateFormatA" (ByVal Locale As Long, ByVal dwFlags As Long, lpDate As SYSTEMTIME, ByVal lpFormat As String, ByVal lpDateStr As String, ByVal cchDate As Long) As Long
Private Declare Function GetLastError Lib "kernel32" () As Long
Private Declare Function GetTimeFormat Lib "kernel32" Alias "GetTimeFormatA" (ByVal Locale As Long, ByVal dwFlags As Long, lpTime As SYSTEMTIME, ByVal lpFormat As String, ByVal lpTimeStr As String, ByVal cchTime As Long) As Long
Private Declare Function CompareString Lib "kernel32" Alias "CompareStringA" (ByVal Locale As Long, ByVal dwCmpFlags As Long, ByVal lpString1 As String, ByVal cchCount1 As Long, ByVal lpString2 As String, ByVal cchCount2 As Long) As Long
Private Declare Function LCMapString Lib "kernel32" Alias "LCMapStringA" (ByVal Locale As Long, ByVal dwMapFlags As Long, ByVal lpSrcStr As String, ByVal cchSrc As Long, ByVal lpDestStr As String, ByVal cchDest As Long) As Long

Private Type CURRENCYFMT
        NumDigits As Long '  number of decimal digits
        LeadingZero As Long '  if leading zero in decimal fields
        Grouping As Long '  group size left of decimal
        lpDecimalSep As String              '  ptr to decimal separator string
        lpThousandSep As String             '  ptr to thousand separator string
        NegativeOrder As Long '  negative currency ordering
        PositiveOrder As Long '  positive currency ordering
        lpCurrencySymbol As String          '  ptr to currency symbol string
End Type
Private Type SYSTEMTIME
        wYear As Integer
        wMonth As Integer
        wDayOfWeek As Integer
        wDay As Integer
        wHour As Integer
        wMinute As Integer
        wSecond As Integer
        wMilliseconds As Integer
End Type
Private Const LOCALE_IOPTIONALCALENDAR = &H100B
Private Const LOCALE_ICENTURY = &H24
Private Const LOCALE_ICOUNTRY = &H5
Private Const LOCALE_ICURRDIGITS = &H19
Private Const LOCALE_ICURRENCY = &H1B
Private Const LOCALE_IDATE = &H21
Private Const LOCALE_IDAYLZERO = &H26
Private Const LOCALE_IDEFAULTCODEPAGE = &HB
Private Const LOCALE_IDEFAULTCOUNTRY = &HA
Private Const LOCALE_IDEFAULTLANGUAGE = &H9
Private Const LOCALE_IDIGITS = &H11
Private Const LOCALE_IINTLCURRDIGITS = &H1A
Private Const LOCALE_ILANGUAGE = &H1
Private Const LOCALE_ILDATE = &H22
Private Const LOCALE_ILZERO = &H12
Private Const LOCALE_IMEASURE = &HD
Private Const LOCALE_IMONLZERO = &H27
Private Const LOCALE_INEGCURR = &H1C
Private Const LOCALE_INEGSEPBYSPACE = &H57
Private Const LOCALE_INEGSIGNPOSN = &H53
Private Const LOCALE_INEGSYMPRECEDES = &H56
Private Const LOCALE_IPOSSEPBYSPACE = &H55
Private Const LOCALE_IPOSSIGNPOSN = &H52
Private Const LOCALE_IPOSSYMPRECEDES = &H54
Private Const LOCALE_ITIME = &H23
Private Const LOCALE_ITLZERO = &H25
Private Const LOCALE_NOUSEROVERRIDE = &H80000000
Private Const LOCALE_S1159 = &H28
Private Const LOCALE_S2359 = &H29
Private Const LOCALE_SABBREVCTRYNAME = &H7
Private Const LOCALE_SABBREVDAYNAME1 = &H31
Private Const LOCALE_SABBREVDAYNAME2 = &H32
Private Const LOCALE_SABBREVDAYNAME3 = &H33
Private Const LOCALE_SABBREVDAYNAME4 = &H34
Private Const LOCALE_SABBREVDAYNAME5 = &H35
Private Const LOCALE_SABBREVDAYNAME6 = &H36
Private Const LOCALE_SABBREVDAYNAME7 = &H37
Private Const LOCALE_SABBREVLANGNAME = &H3
Private Const LOCALE_SABBREVMONTHNAME1 = &H44
Private Const LOCALE_SABBREVMONTHNAME10 = &H4D
Private Const LOCALE_SABBREVMONTHNAME11 = &H4E
Private Const LOCALE_SABBREVMONTHNAME12 = &H4F
Private Const LOCALE_SABBREVMONTHNAME13 = &H100F
Private Const LOCALE_SABBREVMONTHNAME2 = &H45
Private Const LOCALE_SABBREVMONTHNAME3 = &H46
Private Const LOCALE_SABBREVMONTHNAME4 = &H47
Private Const LOCALE_SABBREVMONTHNAME5 = &H48
Private Const LOCALE_SABBREVMONTHNAME6 = &H49
Private Const LOCALE_SABBREVMONTHNAME7 = &H4A
Private Const LOCALE_SABBREVMONTHNAME8 = &H4B
Private Const LOCALE_SABBREVMONTHNAME9 = &H4C
Private Const LOCALE_SCOUNTRY = &H6
Private Const LOCALE_SCURRENCY = &H14
Private Const LOCALE_SDATE = &H1D
Private Const LOCALE_SDAYNAME1 = &H2A
Private Const LOCALE_SDAYNAME2 = &H2B
Private Const LOCALE_SDAYNAME3 = &H2C
Private Const LOCALE_SDAYNAME4 = &H2D
Private Const LOCALE_SDAYNAME5 = &H2E
Private Const LOCALE_SDAYNAME6 = &H2F
Private Const LOCALE_SDAYNAME7 = &H30
Private Const LOCALE_SDECIMAL = &HE
Private Const LOCALE_SENGCOUNTRY = &H1002
Private Const LOCALE_SENGLANGUAGE = &H1001
Private Const LOCALE_SGROUPING = &H10
Private Const LOCALE_SINTLSYMBOL = &H15
Private Const LOCALE_SLANGUAGE = &H2
Private Const LOCALE_SLIST = &HC
Private Const LOCALE_SLONGDATE = &H20
Private Const LOCALE_SMONDECIMALSEP = &H16
Private Const LOCALE_SMONGROUPING = &H18
Private Const LOCALE_SMONTHNAME1 = &H38
Private Const LOCALE_SMONTHNAME10 = &H41
Private Const LOCALE_SMONTHNAME11 = &H42
Private Const LOCALE_SMONTHNAME12 = &H43
Private Const LOCALE_SMONTHNAME2 = &H39
Private Const LOCALE_SMONTHNAME3 = &H3A
Private Const LOCALE_SMONTHNAME4 = &H3B
Private Const LOCALE_SMONTHNAME5 = &H3C
Private Const LOCALE_SMONTHNAME6 = &H3D
Private Const LOCALE_SMONTHNAME7 = &H3E
Private Const LOCALE_SMONTHNAME8 = &H3F
Private Const LOCALE_SMONTHNAME9 = &H40
Private Const LOCALE_SMONTHOUSANDSEP = &H17
Private Const LOCALE_SNATIVECTRYNAME = &H8
Private Const LOCALE_SNATIVEDIGITS = &H13
Private Const LOCALE_SNATIVELANGNAME = &H4
Private Const LOCALE_SNEGATIVESIGN = &H51
Private Const LOCALE_SPOSITIVESIGN = &H50
Private Const LOCALE_SSHORTDATE = &H1F
Private Const LOCALE_STHOUSAND = &HF
Private Const LOCALE_STIME = &H1E
Private Const LOCALE_STIMEFORMAT = &H1003

' This just makes my life a little easier
Private Enum GLITypes
    gliICALENDARTYPE = &H1009
    gliIOPTIONALCALENDAR = &H100B
    gliICENTURY = &H24
    gliICOUNTRY = &H5
    gliICURRDIGITS = &H19
    gliICURRENCY = &H1B
    gliIDATE = &H21
    gliIDAYLZERO = &H26
    gliIDEFAULTCODEPAGE = &HB
    gliIDEFAULTCOUNTRY = &HA
    gliIDEFAULTLANGUAGE = &H9
    gliIDIGITS = &H11
    gliIINTLCURRDIGITS = &H1A
    gliILANGUAGE = &H1
    gliILDATE = &H22
    gliILZERO = &H12
    gliIMEASURE = &HD
    gliIMONLZERO = &H27
    gliINEGCURR = &H1C
    gliINEGSEPBYSPACE = &H57
    gliINEGSIGNPOSN = &H53
    gliINEGSYMPRECEDES = &H56
    gliIPOSSEPBYSPACE = &H55
    gliIPOSSIGNPOSN = &H52
    gliIPOSSYMPRECEDES = &H54
    gliITIME = &H23
    gliITLZERO = &H25
    gliNOUSEROVERRIDE = &H80000000
    gliS1159 = &H28
    gliS2359 = &H29
    gliSABBREVCTRYNAME = &H7
    gliSABBREVDAYNAME1 = &H31
    gliSABBREVDAYNAME2 = &H32
    gliSABBREVDAYNAME3 = &H33
    gliSABBREVDAYNAME4 = &H34
    gliSABBREVDAYNAME5 = &H35
    gliSABBREVDAYNAME6 = &H36
    gliSABBREVDAYNAME7 = &H37
    gliSABBREVLANGNAME = &H3
    gliSABBREVMONTHNAME1 = &H44
    gliSABBREVMONTHNAME10 = &H4D
    gliSABBREVMONTHNAME11 = &H4E
    gliSABBREVMONTHNAME12 = &H4F
    gliSABBREVMONTHNAME13 = &H100F
    gliSABBREVMONTHNAME2 = &H45
    gliSABBREVMONTHNAME3 = &H46
    gliSABBREVMONTHNAME4 = &H47
    gliSABBREVMONTHNAME5 = &H48
    gliSABBREVMONTHNAME6 = &H49
    gliSABBREVMONTHNAME7 = &H4A
    gliSABBREVMONTHNAME8 = &H4B
    gliSABBREVMONTHNAME9 = &H4C
    gliSCOUNTRY = &H6
    gliSCURRENCY = &H14
    gliSDATE = &H1D
    gliSDAYNAME1 = &H2A
    gliSDAYNAME2 = &H2B
    gliSDAYNAME3 = &H2C
    gliSDAYNAME4 = &H2D
    gliSDAYNAME5 = &H2E
    gliSDAYNAME6 = &H2F
    gliSDAYNAME7 = &H30
    gliSDECIMAL = &HE
    gliSENGCOUNTRY = &H1002
    gliSENGLANGUAGE = &H1001
    gliSGROUPING = &H10
    gliSINTLSYMBOL = &H15
    gliSLANGUAGE = &H2
    gliSLIST = &HC
    gliSLONGDATE = &H20
    gliSMONDECIMALSEP = &H16
    gliSMONGROUPING = &H18
    gliSMONTHNAME1 = &H38
    gliSMONTHNAME10 = &H41
    gliSMONTHNAME11 = &H42
    gliSMONTHNAME12 = &H43
    gliSMONTHNAME2 = &H39
    gliSMONTHNAME3 = &H3A
    gliSMONTHNAME4 = &H3B
    gliSMONTHNAME5 = &H3C
    gliSMONTHNAME6 = &H3D
    gliSMONTHNAME7 = &H3E
    gliSMONTHNAME8 = &H3F
    gliSMONTHNAME9 = &H40
    gliSMONTHOUSANDSEP = &H17
    gliSNATIVECTRYNAME = &H8
    gliSNATIVEDIGITS = &H13
    gliSNATIVELANGNAME = &H4
    gliSNEGATIVESIGN = &H51
    gliSPOSITIVESIGN = &H50
    gliSSHORTDATE = &H1F
    gliSTHOUSAND = &HF
    gliSTIME = &H1E
    gliSTIMEFORMAT = &H1003
End Enum

Private Const LCID_INSTALLED = 1
Private Const LCID_SUPPORTED = 2
Private Const SUBLANG_NEUTRAL = &H0
Private Const DATE_LONGDATE = &H2
Private Const DATE_SHORTDATE = &H1
Private Const LCMAP_LOWERCASE = &H100
Private Const LCMAP_UPPERCASE = &H200
Private Const LCMAP_SORTKEY = &H400
Private Const LCMAP_BYTEREV = &H800
Private Const LCMAP_LINGUISTIC_CASING = &H1000000

Private Type DMY
    Day As Integer
    Month As Integer
    year As Long
End Type


Private MonthLens(12) As Integer

Public Property Get AbbrevLangName() As String
AbbrevLangName = pfGLI(gliSABBREVLANGNAME)
End Property

Public Property Get CurrencyString() As String
CurrencyString = pfGLI(gliSCURRENCY)
End Property

Public Property Get DateFormats() As DTFormats
Set DateFormats = mvDF

End Property

Private Function DateOrder(dfStr As String) As String
' Return short-order date format
' This will be in a form similar to "DMY" for a quick look
' at the kind of date format this locale uses

Dim DTX As DTFormat, qOn As Boolean
Dim i As Integer, tDS As String, sChar As String
Dim dIndex As Integer, mIndex As Integer, yIndex As Integer
' We now have the required date type format in dfStr
' Slash through the string and waste anything that's inside single quotes
For i = 1 To Len(dfStr)
    If Mid(dfStr, i, 1) = "'" Then
        If qOn Then qOn = False Else qOn = True
    Else
        If Not qOn Then
            sChar = LCase(Mid(dfStr, i, 1))
            If sChar = "d" Or sChar = "m" Or sChar = "y" Then tDS = tDS + sChar
        End If
    End If
Next

' tDS now holds the date format string stripped of any quoted sections
' Any occurances of "d", "M" or "y" should now be format pictures

' Lose any case problems
tDS = LCase(tDS)
tDS = pfRepStr(tDS, "dddd", "")
tDS = pfRepStr(tDS, "ddd", "")
tDS = pfRepStr(tDS, "dd", "D")
tDS = pfRepStr(tDS, "d", "~")
tDS = pfRepStr(tDS, "~", "D")
tDS = pfRepStr(tDS, "mmmm", "")
tDS = pfRepStr(tDS, "mmm", "")
tDS = pfRepStr(tDS, "mm", "M")
tDS = pfRepStr(tDS, "m", "~")
tDS = pfRepStr(tDS, "~", "M")
tDS = pfRepStr(tDS, "yyyy", "Y")
tDS = pfRepStr(tDS, "yy", "Y")
tDS = pfRepStr(tDS, "y", "~")
tDS = pfRepStr(tDS, "~", "Y")

DateOrder = tDS
'Debug.Print tDS
End Function

Public Function FormatCurrency(CurVal As Double, Optional UseGrouping As Boolean = True, Optional ShowCSymbol As Boolean = True) As String
Dim NumDigits As Integer, LeadingZero As Integer, Grouping As Integer
Dim decSep As String, thouSep As String, negOrder As Integer
Dim posOrder As Integer, cSymb As String
Dim posIntVal As Double, intStr As String
Dim posDecVal As Double, decStr As String
Dim negNum As Boolean, i As Integer
Dim fCur As String

NumDigits = CInt(pfGLI(LOCALE_IDIGITS))
LeadingZero = CInt(pfGLI(gliILZERO))
Grouping = CInt(Left(pfGLI(gliSGROUPING), 1))
decSep = Left(pfGLI(gliSDECIMAL), 1)
thouSep = Left(pfGLI(gliSTHOUSAND), 1)
negOrder = CInt(pfGLI(gliINEGCURR))
posOrder = CInt(pfGLI(gliICURRENCY))
cSymb = pfGLI(gliSCURRENCY)

If Not ShowCSymbol Then cSymb = ""

If CurVal < 0 Then negNum = True
posIntVal = Abs(Fix(CurVal))
posDecVal = Abs(CurVal - Fix(CurVal)) * (10 ^ NumDigits)

intStr = Format(posIntVal, "#############################################")
decStr = Format(posDecVal, String(NumDigits, "0"))

If UseGrouping And Grouping > 0 And Len(intStr) > Grouping Then
    ' Insert the ordinal separators in the integer part of the number
    For i = Grouping To Len(intStr) Step Grouping + 1
        intStr = Left(intStr, Len(intStr) - i) + thouSep + Right(intStr, i)
    Next
End If

' Final format
If negNum Then
    Select Case negOrder
        Case 0
            fCur = "(" + cSymb + intStr + decSep + decStr + ")"
        Case 1
            fCur = "-" + cSymb + intStr + decSep + decStr
        Case 2
            fCur = cSymb + "-" + intStr + decSep + decStr
        Case 3
            fCur = cSymb + intStr + decSep + decStr + "-"
        Case 4
            fCur = "(" + intStr + decSep + decStr + cSymb + ")"
        Case 5
            fCur = "-" + intStr + decSep + decStr + cSymb
        Case 6
            fCur = intStr + decSep + decStr + "-" + cSymb
        Case 7
            fCur = intStr + decSep + decStr + cSymb + "-"
        Case 8
            fCur = "-" + intStr + decSep + decStr + " " + cSymb
        Case 9
            fCur = "-" + cSymb + " " + intStr + decSep + decStr
        Case 10
            fCur = intStr + decSep + decStr + " " + cSymb + "-"
        Case 11
            fCur = cSymb + " " + intStr + decSep + decStr + "-"
        Case 12
            fCur = cSymb + " -" + intStr + decSep + decStr
        Case 13
            fCur = intStr + decSep + decStr + "- " + cSymb
        Case 14
            fCur = "(" + cSymb + " " + intStr + decSep + decStr + ")"
        Case 15
            fCur = "(" + intStr + decSep + decStr + " " + cSymb + ")"
        Case Else
            fCur = "-" + cSymb + intStr + decSep + decStr
    End Select
Else
    Select Case posOrder
        Case 0
            fCur = cSymb + intStr + decSep + decStr
        Case 1
            fCur = intStr + decSep + decStr + cSymb
        Case 2
            fCur = cSymb + " " + intStr + decSep + decStr
        Case 3
            fCur = intStr + decSep + decStr + " " + cSymb
        Case Else
            fCur = cSymb + intStr + decSep + decStr
    End Select
End If

FormatCurrency = Trim(fCur)
        

End Function

Public Function FormatNumber(FNumber As Double, Optional NumDecimalPlaces As Integer = 2, Optional UseGrouping As Boolean = True) As String
Dim NumDigits As Integer, LeadingZero As Integer, Grouping As Integer
Dim decSep As String, thouSep As String, negOrder As Integer
Dim posOrder As Integer, cSymb As String
Dim posIntVal As Double, intStr As String
Dim posDecVal As Double, decStr As String
Dim negNum As Boolean, i As Integer
Dim fCur As String

'NumDigits = CInt(pfGLI(LOCALE_IDIGITS))
LeadingZero = CInt(pfGLI(gliILZERO))
Grouping = CInt(Left(pfGLI(gliSGROUPING), 1))
decSep = Left(pfGLI(gliSDECIMAL), 1)
thouSep = Left(pfGLI(gliSTHOUSAND), 1)
negOrder = CInt(pfGLI(gliINEGCURR))
posOrder = CInt(pfGLI(gliICURRENCY))
cSymb = ""


If FNumber < 0 Then negNum = True
posIntVal = Abs(Fix(FNumber))
posDecVal = Abs(FNumber - Fix(FNumber)) * (10 ^ NumDecimalPlaces)

intStr = Format(posIntVal, "#############################################")
decStr = Format(posDecVal, String(NumDecimalPlaces, "0"))

If UseGrouping And Grouping > 0 And Len(intStr) > Grouping Then
    ' Insert the ordinal separators in the integer part of the number
    For i = Grouping To Len(intStr) Step Grouping + 1
        intStr = Left(intStr, Len(intStr) - i) + thouSep + Right(intStr, i)
    Next
End If

' Final format
If negNum Then
    Select Case negOrder
        Case 0
            fCur = "(" + cSymb + intStr + decSep + decStr + ")"
        Case 1
            fCur = "-" + cSymb + intStr + decSep + decStr
        Case 2
            fCur = cSymb + "-" + intStr + decSep + decStr
        Case 3
            fCur = cSymb + intStr + decSep + decStr + "-"
        Case 4
            fCur = "(" + intStr + decSep + decStr + cSymb + ")"
        Case 5
            fCur = "-" + intStr + decSep + decStr + cSymb
        Case 6
            fCur = intStr + decSep + decStr + "-" + cSymb
        Case 7
            fCur = intStr + decSep + decStr + cSymb + "-"
        Case 8
            fCur = "-" + intStr + decSep + decStr + " " + cSymb
        Case 9
            fCur = "-" + cSymb + " " + intStr + decSep + decStr
        Case 10
            fCur = intStr + decSep + decStr + " " + cSymb + "-"
        Case 11
            fCur = cSymb + " " + intStr + decSep + decStr + "-"
        Case 12
            fCur = cSymb + " -" + intStr + decSep + decStr
        Case 13
            fCur = intStr + decSep + decStr + "- " + cSymb
        Case 14
            fCur = "(" + cSymb + " " + intStr + decSep + decStr + ")"
        Case 15
            fCur = "(" + intStr + decSep + decStr + " " + cSymb + ")"
        Case Else
            fCur = "-" + cSymb + intStr + decSep + decStr
    End Select
Else
    Select Case posOrder
        Case 0
            fCur = cSymb + intStr + decSep + decStr
        Case 1
            fCur = intStr + decSep + decStr + cSymb
        Case 2
            fCur = cSymb + " " + intStr + decSep + decStr
        Case 3
            fCur = intStr + decSep + decStr + " " + cSymb
        Case Else
            fCur = cSymb + intStr + decSep + decStr
    End Select
End If

FormatNumber = Trim(fCur)
        

End Function


Public Function FormatDate(DateVar As Date, Optional DateFormat As Variant = lShortDate) As String
Dim dfVT As Long, tS As String
Dim sT As SYSTEMTIME, aStr As String, dConst As Long

' Determine the type of DateFormat
' Can be either a numeric lShortDate or lLongDate, or a picture string for a custom format
dfVT = VarType(DateFormat)

' Initialise the systemtime structure and the buffer for the result
sT.wDay = DatePart("d", DateVar)
sT.wMonth = DatePart("m", DateVar)
sT.wYear = DatePart("yyyy", DateVar)
aStr = String(255, Chr(0))

If dfVT = vbString Then
    ' We need to use a custom format
    tS = CStr(DateFormat)
    GetDateFormat mvLCID, 0, sT, tS, aStr, 255
Else
    ' Use the selected generic format
    If DateFormat = lLongDate Then dConst = DATE_LONGDATE Else dConst = DATE_SHORTDATE
    GetDateFormat mvLCID, dConst, sT, vbNullString, aStr, 255
End If

' Trim the string in the buffer
FormatDate = Left(aStr, InStr(1, aStr, Chr(0)) - 1)
End Function

Public Function FormatTime(TimeVar As Date, Optional TimeFormat As String = "") As String
Dim sT As SYSTEMTIME, aStr As String

' Initialise the systemtime structure and the buffer for the result
sT.wHour = DatePart("h", TimeVar)
sT.wMinute = DatePart("n", TimeVar)
sT.wSecond = DatePart("s", TimeVar)
sT.wMilliseconds = 0        ' Currently ignores milliseconds - I don't think many locales use them

aStr = String(255, Chr(0))

If TimeFormat = "" Then
    GetTimeFormat mvLCID, 0&, sT, vbNullString, aStr, 255
Else
    GetTimeFormat mvLCID, 0&, sT, TimeFormat, aStr, 255
End If


' Trim the string in the buffer
FormatTime = Left(aStr, InStr(1, aStr, Chr(0)) - 1)

End Function


Public Property Get FullName() As String
FullName = pfGLI(gliSLANGUAGE)
End Property


Public Property Get GenericLangName() As String
GenericLangName = pfGLI(gliSENGLANGUAGE)
End Property


Public Function GetDayName(DayIndex As Integer, Optional Abbreviate As Boolean = False) As String
If DayIndex < 1 Or DayIndex > 7 Then
    Err.Raise vbObjectError, "Locale", "Day index out of range (1-7 only)"
    Exit Function
End If
Dim aln As String, dayConst As Long
If Abbreviate Then dayConst = gliSABBREVDAYNAME1 Else dayConst = gliSDAYNAME1
dayConst = dayConst + DayIndex - 1
GetDayName = pfGLI(dayConst)
End Function

Public Function GetMonthName(MonthIndex As Integer, Optional Abbreviate As Boolean = False) As String
If MonthIndex < 1 Or MonthIndex > 12 Then
    ' Numbers up to 13 allowed for Lunar calendars
    Err.Raise vbObjectError, "Locale", "Month index out of range (1-12 only)"
    Exit Function
End If
Dim aln As String, dayConst As Long
If Abbreviate Then dayConst = gliSABBREVMONTHNAME1 Else dayConst = gliSMONTHNAME1
dayConst = dayConst + MonthIndex - 1
GetMonthName = pfGLI(dayConst)
End Function


Public Property Get IntlCurrencyCode() As String
IntlCurrencyCode = pfGLI(gliSINTLSYMBOL)
End Property

Public Property Get isValid() As Boolean
Dim rv As Long, sX As String
If IsValidLocale(mvLCID, LCID_INSTALLED) = 1 Then isValid = True Else isValid = False
End Property

Public Property Get LCID() As Long
LCID = mvLCID
End Property

Public Function ListSort(List() As String, Optional Ascending As Boolean = True, Optional CaseSensitive As Boolean = True) As String()
' Sort a list according to locale conventions
Dim tStr() As String, i As Long, j As Long
Dim selNum As Long, rv As Long
Dim resPtr As Long, resStr() As String
Dim dwCmpFlags As Long

If CaseSensitive Then dwCmpFlags = 1&

' Copy the array into a temporary one
ReDim tStr(LBound(List) To UBound(List))
ReDim resStr(0 To UBound(List))
For i = LBound(List) To UBound(List)
    tStr(i) = List(i)
Next

resPtr = 0

' now we can mess around with tStr without destroying the user's original data
' Loop through the array
For i = LBound(tStr) To UBound(tStr)
    ' Looping through for each entry
    selNum = -1
    ' Now find the next <lowest/highest> entry
    For j = LBound(tStr) To UBound(tStr)
        If tStr(j) <> "" Then ' If this isn't an already deleted entry then
            If selNum = -1 Then
                selNum = j
            Else
                ' Compare strings here
                rv = CompareString(mvLCID, dwCmpFlags, tStr(j), -1&, tStr(selNum), -1&)
                Debug.Print "Compare : " + tStr(j) + " to " + tStr(selNum) + " = " + CStr(rv)
                Select Case rv
                    Case 0
                        ' Failure!
                        Err.Raise 1, "Locale.ListSort", "Unable to sort list"
                        Exit Function
                    Case 1
                        ' tStr(j) < tStr(selNum)
                        If Ascending Then
                            selNum = j
                        End If
                    Case 2
                        ' tStr(j) = tStr(selNum)
                        ' Do nothing
                    Case 3
                        ' tStr(j) > tStr(selNum)
                        If Ascending = False Then
                            selNum = j
                        End If
                End Select
            End If
        End If
    Next
    ' Now we have the number of the item to pass
    On Error Resume Next
    resStr(resPtr) = tStr(selNum)
    resPtr = resPtr + 1
    tStr(selNum) = ""
Next
ReDim Preserve resStr(resPtr - 2)
ListSort = resStr
End Function



Public Function LocaleCDate(DateExpression As String) As Date
' Convert a date literal formatted for this locale into a VB Date type variable
' This is really a rather evil fudge
Dim i As Integer, longDF As Boolean
Dim numerics() As Integer, nPtr As Integer, tS As String, tNS As String
Dim dayNum As Integer, monthNum As Integer, YearNum As Long
Dim ldFormat As String, sdFormat As String
Dim dT As DMY, finalDate As Date, DFx As DTFormat
Dim fvDate As Boolean, mnFollowers As String, mnCtr As Integer, cFollower As String
Dim nDateExp As String
' Get the default long and short date formats for this locale
ldFormat = pfGLI(gliSLONGDATE)
sdFormat = pfGLI(gliSSHORTDATE)

mnFollowers = " ,."

    ' If it's a long date format then it will include the local name of the month (in either abbreviated or long form)
    ' Check for long month names
    If longDF = False Then
        For i = 1 To 12
            If InStr(1, DateExpression, GetMonthName(i, False) + cFollower) > 0 Then
                longDF = True
                monthNum = i
                Exit For
            End If
        Next
    End If
    ' Check for short month names
    If longDF = False Then
        For i = 1 To 12
            If InStr(1, DateExpression, GetMonthName(i, True) + cFollower) > 0 Then
                longDF = True
                monthNum = i
                Exit For
            End If
        Next
    End If
    ' Check for inflected long month (some languages have month names that inflect on use)
    If longDF = False Then
        For i = 1 To 12
            If InStr(1, DateExpression, pfGetUsedMN(i, False) + cFollower) > 0 Then
                longDF = True
                monthNum = i
                Exit For
            End If
        Next
    End If
    ' Check for inflected short month names (Shouldn't be different from non-inflected, but you never know)
    If longDF = False Then
        For i = 1 To 12
            If InStr(1, DateExpression, pfGetUsedMN(i, True) + cFollower) > 0 Then
                longDF = True
                monthNum = i
                Exit For
            End If
        Next
    End If



' Now that I know what kind of date it is I can tailor the rest of the routine
' Copy all of the numbers from the string into an array
ReDim numerics(1)
For i = 1 To Len(DateExpression)
    tS = Mid(DateExpression, i, 1)
    If Asc(tS) >= Asc("0") And Asc(tS) <= Asc("9") Then
        ' It's a numeric character
        tNS = tNS + tS
    Else
        If Len(tNS) > 0 Then
            ' Non-numeric character and our number string buffer (tns) has something in it
            ReDim Preserve numerics(UBound(numerics) + 1)
            numerics(UBound(numerics)) = CInt(tNS)
            tNS = ""
        End If
    End If
Next
If tNS <> "" Then
    ReDim Preserve numerics(UBound(numerics) + 1)
    numerics(UBound(numerics)) = CInt(tNS)
End If

' OK, we now have the numeric terms in an array and know whether it's a long or short date
nPtr = 2
If longDF Then
    ' Long date format - start sorting out the numbers
    ' Check to see if the default date format produces good results
    dT = pfGetDMY(numerics(), pfDateOrder(ldFormat))
    dT.Month = monthNum
    If pfValidateDMY(dT) Then
        finalDate = DateSerial(dT.year, dT.Month, dT.Day)
        fvDate = True
    Else
        ' Run through all long date formats and check each one
        For Each DFx In mvTF
            If DFx.DTFType = dtfLongDate Then
                dT = pfGetDMY(numerics(), pfDateOrder(DFx.DTFormat))
                dT.Month = monthNum
                If pfValidateDMY(dT) Then
                    finalDate = DateSerial(dT.year, dT.Month, dT.Day)
                    fvDate = True
                    Exit For
                End If
            End If
        Next
    End If
Else
    ' Short date format
    dT = pfGetDMY(numerics(), pfDateOrder(sdFormat))
    If pfValidateDMY(dT) Then
        finalDate = DateSerial(dT.year, dT.Month, dT.Day)
        fvDate = True
    Else
        ' Run through all short date formats and check each one
        For Each DFx In mvTF
            If DFx.DTFType = dtfShortDate Then
                dT = pfGetDMY(numerics(), pfDateOrder(DFx.DTFormat))
                If pfValidateDMY(dT) Then
                    finalDate = DateSerial(dT.year, dT.Month, dT.Day)
                    fvDate = True
                    Exit For
                End If
            End If
        Next
    End If
End If
If fvDate Then
    LocaleCDate = finalDate
Else
    Err.Raise vbObjectError + 1, "Locale " + Me.AbbrevLangName, "Unable to parse date"
End If

End Function

Public Function LocaleDTime(TimeExpression As String) As Date
' Returns time string as a date
' All locales I can get info on use the HH:MM:SS type format
' Specifically with hours, minutes and seconds always in that order
' So I'm asuming that that is what we're being passed




' Adjust for AM or PM

' TimeSerial...
End Function


Public Function LocaleLCase(InputString As String) As String
Dim res As String, rv As Long
res = String(Len(InputString) * 2, Chr(0))
rv = LCMapString(mvLCID, LCMAP_LOWERCASE, InputString, -1&, res, (Len(InputString) * 2))
LocaleLCase = Left(res, rv)
End Function

Public Function LocaleUCase(InputString As String) As String
Dim res As String, rv As Long
res = String(Len(InputString) * 2, Chr(0))
rv = LCMapString(mvLCID, LCMAP_UPPERCASE, InputString, -1&, res, (Len(InputString) * 2))
LocaleUCase = Left(res, rv)
End Function
Public Property Get LongDateFormat() As String
LongDateFormat = pfGLI(gliSLONGDATE)
End Property

Public Property Get NativeCountryName() As String
NativeCountryName = pfGLI(gliSNATIVECTRYNAME)
End Property

Public Property Get NativeLangName() As String
NativeLangName = pfGLI(gliSNATIVELANGNAME)
End Property

Private Function pfDateOrder(dfStr As String) As String
' Return short-order date format
' dfStr should contain a date format picture string
' This will be in a form similar to "DMY" for a quick look
' at the kind of date format this locale uses

Dim qOn As Boolean
Dim i As Integer, tDS As String, sChar As String
Dim dIndex As Integer, mIndex As Integer, yIndex As Integer
' Slash through the picture string and waste anything that's inside single quotes
For i = 1 To Len(dfStr)
    If Mid(dfStr, i, 1) = "'" Then
        If qOn Then qOn = False Else qOn = True
    Else
        If Not qOn Then
            sChar = LCase(Mid(dfStr, i, 1))
            If sChar = "d" Or sChar = "m" Or sChar = "y" Then tDS = tDS + sChar
        End If
    End If
Next

' tDS now holds the date format string stripped of any quoted sections
' Any occurances of "d", "M" or "y" should now be format pictures

' Lose any case problems
tDS = LCase(tDS)
tDS = pfRepStr(tDS, "dddd", "")
tDS = pfRepStr(tDS, "ddd", "")
tDS = pfRepStr(tDS, "dd", "D")
tDS = pfRepStr(tDS, "mmmm", "")
tDS = pfRepStr(tDS, "mmm", "")
tDS = pfRepStr(tDS, "mm", "M")
tDS = pfRepStr(tDS, "yyy", "Y")
tDS = pfRepStr(tDS, "yyyy", "Y")
tDS = pfRepStr(tDS, "yy", "Y")

pfDateOrder = tDS
End Function

Private Function pfGetDMY(numArray() As Integer, dOrder As String) As DMY
Dim i As Integer, nPtr As Integer
nPtr = 2
For i = 1 To Len(dOrder)
    Select Case Mid(dOrder, i, 1)
        Case "d"
            pfGetDMY.Day = numArray(nPtr)
            nPtr = nPtr + 1
        Case "m"
            pfGetDMY.Month = numArray(nPtr)
            nPtr = nPtr + 1
        Case "y"
            pfGetDMY.year = numArray(nPtr)
            nPtr = nPtr + 1
    End Select
Next
' Adjust the year here if only 2 digits
pfGetDMY.year = pfYAdj(pfGetDMY.year)
End Function

Public Function pfGetUsedMN(MonthIndex As Integer, Optional Abbreviate As Boolean = False) As String
If MonthIndex < 1 Or MonthIndex > 12 Then
    ' Numbers up to 13 allowed for Lunar calendars
    Err.Raise vbObjectError, "Locale", "Month index out of range (1-12 only)"
    Exit Function
End If
Dim sT As SYSTEMTIME, tS As String, mnI As String, sP As Integer
If Abbreviate Then mnI = "dd MMM" Else mnI = "dd MMMM"
sT.wMonth = MonthIndex
sT.wYear = 1999
sT.wDay = 21
tS = String(255, Chr(0))
GetDateFormat mvLCID, 0, sT, mnI, tS, 255
tS = Left(tS, InStr(tS, Chr(0)) - 1)
sP = InStr(1, tS, " ")
tS = Right(tS, Len(tS) - sP)
pfGetUsedMN = tS

End Function

Private Function pfGLI(reqInfo As GLITypes) As String
Dim aStr As String
aStr = String(255, Chr(0))
GetLocaleInfo mvLCID, reqInfo, aStr, 255
aStr = Left(aStr, InStr(1, aStr, Chr(0)) - 1)
pfGLI = aStr
End Function

Private Function pfMAKELCID(PLang As Long, SLang As Long) As Long
Dim tX As Long
tX = SLang * 2 ^ 10
tX = tX Or PLang
pfMAKELCID = tX
End Function
Private Function pfRepStr(constr As String, findstr As String, repstr As String) As String
If InStr(1, constr, findstr) < 1 Then
    pfRepStr = constr
    Exit Function
End If
Dim i As Integer, tStr As String, iStr As String
iStr = constr
i = InStr(1, iStr, findstr)
Do While i > 0
    If i > 1 Then tStr = Left(iStr, i - 1) Else tStr = ""
    tStr = tStr + repstr
    If (Len(iStr) - i - Len(findstr) + 1) > 0 Then tStr = tStr + Right(iStr, Len(iStr) - i - Len(findstr) + 1)
    iStr = tStr
    i = InStr(1, iStr, findstr)
Loop
pfRepStr = iStr
End Function

Private Function pfValidateDMY(dX As DMY) As Boolean
' Validate the values in a DMY type
pfValidateDMY = False
' Swift validations
If dX.Day > 31 Or dX.Day < 1 Then Exit Function
If dX.Month > 12 Or dX.Month < 1 Then Exit Function
' Lengthier validations
Dim tD As Date, tY As Long, tM As Integer, mLen As Integer
tY = pfYAdj(dX.year)
tM = dX.Month + 1
If tM > 12 Then tM = 1
tD = DateSerial(tY, tM, 1)
tD = DateAdd("d", -1, tD)
mLen = CInt(Format(tD, "dd"))
' mLen now holds the length of the actual month we believe it to be
If dX.Day > mLen Then Exit Function
' Assuming it passes all of these tests return true indicating that it seems to be a valid date breakdown
pfValidateDMY = True
End Function

Private Function pfYAdj(YearNum As Long) As Long
' Adjust year if under 100 (i.e. select whether 20xx or 19xx)
If YearNum < 100 Then
    If YearNum < 50 Then pfYAdj = YearNum + 2000 Else pfYAdj = YearNum + 1900
Else
    pfYAdj = YearNum
End If
End Function

Friend Sub SetLanuage(PRLang As Long, Optional SubLang As Long = SUBLANG_NEUTRAL)
mvPrLang = PRLang
mvSubLang = SubLang
mvLCID = pfMAKELCID(PRLang, SubLang)

If IsValidLocale(mvLCID, LCID_INSTALLED) <> 1 Then Exit Sub
'Debug.Print Me.GenericLangName

' Now that language is set enum the available formats
EnumFormats mvLCID
' The sub in the module will have populated some arrays with the dateformats for my LCID
Dim DFx As DTFormat, i As Integer
Set mvDF = New Collection
' Short dates
If iSDFs > 0 Then
    For i = LBound(ShortDateFMT) + 1 To UBound(ShortDateFMT)
        Set DFx = New DTFormat
        DFx.DTFormat = ShortDateFMT(i)
        DFx.DTFType = dtfShortDate
        mvDF.Add DFx
    Next
End If
' Long dates
If iLDFs > 1 Then
    For i = LBound(LongDateFMT) + 1 To UBound(LongDateFMT)
        Set DFx = New DTFormat
        DFx.DTFormat = LongDateFMT(i)
        DFx.DTFType = dtfLongDate
        mvDF.Add DFx
    Next
End If
' Times
Set mvTF = New Collection
If iTFs > 0 Then
    For i = LBound(TimeFMT) + 1 To UBound(TimeFMT)
        Set DFx = New DTFormat
        DFx.DTFormat = TimeFMT(i)
        DFx.DTFType = dtfTime
        mvTF.Add DFx
    Next
End If

' Clear arrays
Erase ShortDateFMT, LongDateFMT, TimeFMT
End Sub


Public Property Get ShortDateFormat() As String
ShortDateFormat = pfGLI(gliSSHORTDATE)
End Property

Public Property Get TimeFormats() As DTFormats
If mvTF Is Nothing Then
    Set TimeFormats = Nothing
    Exit Property
End If
Set TimeFormats = mvTF
End Property


Private Sub Class_Initialize()
MonthLens(1) = 31
MonthLens(2) = 29
MonthLens(3) = 31
MonthLens(4) = 30
MonthLens(5) = 31
MonthLens(6) = 30
MonthLens(7) = 31
MonthLens(8) = 31
MonthLens(9) = 30
MonthLens(10) = 31
MonthLens(11) = 30
MonthLens(12) = 31
End Sub

Private Sub Class_Terminate()
'Debug.Print Me.AbbrevLangName + " destroyed"
Set mvDF = Nothing
Set mvTF = Nothing

End Sub


